#include "declarations.h"
#include <SoftwareSerial.h>



int latchPin = 10;
int clockPin = 13;
int dataPin = 11;
int clock = 9;
int Reset = 8;
int latchPinPORTB = latchPin - 8;
int clockPinPORTB = clockPin - 8;
int dataPinPORTB = dataPin - 8;
int i = 0;
int incomingByte[90]; //controls how many letters you can display at once. 
long scrolling_word[8];
int array_turn=0;
byte patterns[100][8];
byte dummy_array[96][8] ={BA,BB,BC,BD,BE,BF,BG,BH,BI,BJ,
BK,BL,BM,BN,BO,BP,BQ,BR,BS,BT,
BU,BV,BW,BX,BY,BZ,SPACE,NUM0,NUM1,NUM2,
NUM3,NUM4,NUM5,NUM6,NUM7,NUM8,NUM9,DEVIDE,TWODOTS,DOT,
COMA,LINE,QUASTION,MARK,LA,LB,LC,LD,LE,LF,
LG,LH,LI,LJ,LK,LL,LM,LN,LO,LP,
LQ,LR,LS,LT,LU,LV,LW,LX,LY,LZ,
SMILEY,QUOT,POUND,DOLLAR,PERCENT,AND,SINQUOT,LPARENTH,RPARENTH,ASTERISK,
PLUS,BACKSLASH,LESTHAN,GREATTHAN,EQUAL,AT,CARAT,LBRACKET,RBRACKET,VERTLINE,
TILDE,BACKTICK,SEMICOLON,LSQBRACKET,RSQBRACKET,UNDERSCORE};
SoftwareSerial BTSerial(7, 6); // RX | TX
void setup(){
  pinMode(dataPin,OUTPUT);
  pinMode(clockPin,OUTPUT);
  pinMode(latchPin,OUTPUT);
  pinMode(clock,OUTPUT);
  pinMode(Reset,OUTPUT);
  digitalWrite(Reset,HIGH);
  digitalWrite(Reset,LOW);
  setupSPI();
  BTSerial.begin(9600);
}



  void loop() {

	// send data only when you receive data:
	if(BTSerial.available() > 0){
		delay(100);
		incomingByte[array_turn] = BTSerial.read();
                array_turn++;
	}
           else{
             if(array_turn != 0){ 
               for(int az=0;az<array_turn;az++){
                 if((incomingByte[az] > 64 && incomingByte[az] < 91) || (incomingByte[az] > 96 && incomingByte[az] < 123)){
                  if(incomingByte[az] > 64 && incomingByte[az] < 91){
                   for(int lal=0;lal<8;lal++)                 
                 patterns[az][lal] = dummy_array[incomingByte[az] - 65][lal];
               }
               else{
                 for(int lal=0;lal<8;lal++)                 
                 patterns[az][lal] = dummy_array[incomingByte[az] - 53][lal];
               }}
               else{
                 switch(incomingByte[az]){
                case 32://space
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[26][lol];
                 break;
                case 33://mark
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[43][lol];
                 break;
                case 45://line
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[41][lol];
                 break;                 
                 case 44://coma
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[40][lol];
                 break;
                 case 46://dot
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[39][lol];
                 break;
                 case 47://dvide
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[37][lol];
                 break;
                 case 48://0
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[27][lol];
                 break;
                 case 49://1
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[28][lol];
                 break;
                 case 50://2
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[29][lol];
                 break;
                 case 51://3
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[30][lol];
                 break;
                 case 52://4
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[31][lol];
                 break;
                 case 53://5
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[32][lol];
                 break;
                 case 54://6
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[33][lol];
                 break;
                 case 55://7
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[34][lol];
                 break;
                 case 56://8
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[35][lol];
                 break;
                 case 57://9
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[36][lol];
                 break;
                 case 58://tow dots
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[38][lol];
                 break;
                 case 63://quastion
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[42][lol];
                 break;
                 
                  case 34://quote
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[71][lol];
                 break;
                  case 35://pound
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[72][lol];
                 break;
                  case 36://dollar
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[73][lol];
                 break;
                  case 37://percent
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[74][lol];
                 break;
                  case 38://and
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[75][lol];
                 break;
                  case 39://single quote
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[76][lol];
                 break;
                  case 40://left parenthese
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[77][lol];
                 break;
                  case 41://right parenthase
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[78][lol];
                 break;
                  case 42://asterisk
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[79][lol];
                 break;
                  case 43://plus
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[80][lol];
                 break;
    
        
                  case 59://semicolon
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[92][lol];
                 break;
                  case 60://less than
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[82][lol];
                 break;
                  case 61://equals
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[84][lol];
                 break;
                  case 62://greater than
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[83][lol];
                 break;
                  case 64://at
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[85][lol];
                 break;
                  case 91://Left square bracket
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[93][lol];
                 break;
                  case 92://backslash
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[81][lol];
                 break;
                  case 93://right square bracket
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[94][lol];
                 break;
                  case 94://carat (^)
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[86][lol];
                 break;
                 
                  case 95://underscore
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[95][lol];
                 break;
                  case 96://backtick
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[91][lol];
                 break;
                  case 123://left bracket
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[87][lol];
                 break;
                  case 124://vertical line
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[89][lol];
                 break;
                  case 125://right bracket
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[88][lol];
                 break;
                  case 126://tilde
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[90][lol];
                 break;
                 
                 
                 default:
                 for(int lol=0;lol<8;lol++)                 
                 patterns[az][lol] = dummy_array[26][lol];
                 break; 
                 }
               }               
             }
           }
          display_word(1,patterns,array_turn,10);
          array_turn =0; 
         } 
       }
  
  //display_word(1,patterns,43,15);// calls for the display_pattern function and says that int loop = 15(if you do more loop the pattern whould scrol slower).


